<?php
declare(strict_types=1);

namespace Flat101\EnhancedEcommerce\Model\Handler\Click;

use Flat101\EnhancedEcommerce\Model\DataLayer\Generator\ClickImpression;
use Flat101\EnhancedEcommerce\Model\Session;
use Flat101\EnhancedEcommerce\Helper\Config;

class ClickSearchImpressionHandler implements ClickImpressionHandlerInterface
{
    /** @var Session */
    private $session;

    /** @var ClickImpression */
    private $clickImpressionGenerator;

    /** @var Config */
    private $configHelper;

    public function __construct(
        Session $session,
        ClickImpression $clickImpressionGenerator,
        Config $configHelper
    ) {
        $this->session = $session;
        $this->clickImpressionGenerator = $clickImpressionGenerator;
        $this->configHelper = $configHelper;
    }

    public function handle($product, $clickData = null): void
    {
        $listLabel = $this->configHelper->getListLabelSearchImpressions();
        $this->session->setClickImpressionProducts(
            $this->clickImpressionGenerator->generate($product, ($clickData['list']) ?? $listLabel, $clickData)
        );
    }
}
